// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/widgets.dart';
import 'package:wyatt_component_copy_with_extension/component_copy_with_extension.dart';
import 'package:wyatt_ui_components/src/domain/entities/buttons/simple_icon_button_style.dart';
import 'package:wyatt_ui_components/wyatt_wyatt_ui_components.dart';

part 'simple_icon_button_component.g.dart';

@ComponentProxyExtension()
abstract class SimpleIconButtonComponent extends ButtonComponent
    with CopyWithMixin<$SimpleIconButtonComponentCWProxy> {
  const SimpleIconButtonComponent({
    this.icon,
    super.disabledStyle,
    super.normalStyle,
    super.hoveredStyle,
    super.focusedStyle,
    super.tappedStyle,
    super.selectedStyle,
    super.onPressed,
    super.key,
  });

  @override
  SimpleIconButtonStyle? get disabledStyle;

  @override
  SimpleIconButtonStyle? get normalStyle;

  @override
  SimpleIconButtonStyle? get hoveredStyle;

  @override
  SimpleIconButtonStyle? get focusedStyle;

  @override
  SimpleIconButtonStyle? get tappedStyle;

  @override
  SimpleIconButtonStyle? get selectedStyle;

  final Icon? icon;
}
